/* 
  ஢塞 祭   ஭  㣮쭨 (p4,p5)
   㣨 㣮쭨 (p1,p2,p3)
   믮 ᫮
  p4+a*(p5-p4)=p1+b*(p2-p1)+c*(p3-p2)
   0<=a<=1, 0<=b<=1, 0<=c<=b
  蠥 ⥬    ࠢ  
  ஢塞 祭 a,b,c
 */
#include <stdio.h>
#include <math.h>
double matr[3][4];
double res[3];
double eps=1e-6;
double det(int i1, int i2, int i3)
{
  return matr[0][i1]*(matr[1][i2]*matr[2][i3]-matr[2][i2]*matr[1][i3])-
         matr[0][i2]*(matr[1][i1]*matr[2][i3]-matr[2][i1]*matr[1][i3])+
         matr[0][i3]*(matr[1][i1]*matr[2][i2]-matr[2][i1]*matr[1][i2]);
}
int cross(double p1[], double p2[], double p3[], double p4[], double p5[])
{
  double a,b,c,d;
  int i;
  for(i=0;i<3;i++)
  { matr[i][0]=p5[i]-p4[i];
    matr[i][1]=p1[i]-p2[i];
    matr[i][2]=p2[i]-p3[i];
    matr[i][3]=p1[i]-p4[i];
  }
  d=det(0,1,2);
  if(fabs(d)<eps) return 0;
  a=det(3,1,2)/d;
  if(a<-eps || a>1+eps) return 0;
  b=det(0,3,2)/d;
  if(b<-eps || b>1+eps) return 0;
  c=det(0,1,3)/d;
  if(c<-eps || c>b+eps) return 0;
  return 1;
}
int main()
{
  double pts[6][3];
  int i,r=0;
  freopen("input.txt","r",stdin);
  freopen("output.txt","w",stdout);
  for(i=0;i<6;++i)
    scanf("%lf%lf%lf",&pts[i][0],&pts[i][1],&pts[i][2]);
  if(cross(pts[3],pts[4],pts[5],pts[0],pts[1]) ||
     cross(pts[3],pts[4],pts[5],pts[0],pts[2]) ||
     cross(pts[3],pts[4],pts[5],pts[2],pts[1])) r+=1;
  if(cross(pts[0],pts[1],pts[2],pts[3],pts[4]) ||
     cross(pts[0],pts[1],pts[2],pts[3],pts[5]) ||
     cross(pts[0],pts[1],pts[2],pts[4],pts[5])) r+=2;
  printf("%d\n",r);
  return 0;
}
